

require_relative "rotlib/version"
require 'net/http';

module Rotlib
  def toHex(data)
    return data.dump.bytes.map {|e| e.to_s(16)}.join
  end
  def fromHex(data)
    return data.split.pack('H*')
  end

  def rot13(words, iter = 13)
    tmp_value = ''
    words.bytes.map do |c|
      if c > 64 and c < 91
        c += iter
        loop do
          if c > 90
            c = (c - 90)+64
          end
          break if c > 64 and c < 91
        end
      elsif c > 96 and c < 123
        c += iter
        loop do
          if c > 122
            c = (c - 122)+96
          end
          break if c > 96 and c < 123
        end
      end
      tmp_value += c.chr
    end
    return tmp_value
  end

  def rot13_log(words, show_max_length = 25)
    if words.length > show_max_length
      words = words.split("\n")[0]
      words = words[0,show_max_length]
    end
    26.times do |i|
      puts "#{i.to_s.rjust 2} \e[32;m>\e[0m #{rot13(words, i)}"
    end
    return
  end

  def rot47(words,  iter = 47)
    tmp_value = ''
    words.bytes.map do |c|
      if c > 32 and c < 127
        c += iter
        loop do
          if c > 126
            c = (c - 126)+32
          end
          break if c > 32 and c < 127
        end
      end
      tmp_value += c.chr
    end
    return tmp_value
  end

  def rot47_log(words, show_max_length = 25)
    if words.length > show_max_length
      words = words.split("\n")[0]
      words = words[0,show_max_length]
    end
    94.times do |i|
      puts "#{i.to_s.rjust 2} \e[32;m>\e[0m #{rot47(words, i)}"
    end
    return
  end

  def url_encode(url2encode)
    return URI.encode_www_form_component(url2encode)
  end
  def url_decode(url2decode)
    return URI::decode_www_form_component(url2decode)
  end
end

include Rotlib
